// =======================================================================
// 
//       Filename:  callinfo.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  03.06.2010 16:34:10
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "callinfo.hpp"
#include <stdexcept>

using namespace std;
using namespace boost;

namespace wesl {
    CallInfo::CallInfo() 
        : m_args(0),
        m_element(0)
    {

    }

    CallInfo::CallInfo(ObjectPointerList& args,
            elements::Command& element)
        : m_args(&args),
        m_element(&element)
    {

    }

    CallInfo::ObjectPointerList& CallInfo::arguments() const
    {
        if(m_args == 0)
            throw logic_error("wesl::CallInfo::arguments: "
                              "wesl::CallInfo::m_args not set");

        return *m_args;
    }

    elements::Command& CallInfo::element() {
        if(m_element == 0)
            throw logic_error("wesl::CallInfo::element: "
                              "wesl::CallInfo::m_element not set");

        return *m_element;
    }
}
