// =======================================================================
// 
//       Filename:  callinfo.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  03.06.2010 16:29:27
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  CALLINFO_INC
#define  CALLINFO_INC
#include <fstream>
#include <vector>
#include <boost/shared_ptr.hpp>

namespace wesl {
    class Processor;
    namespace types {
        class Object;
    }

    namespace utils {
        class CIterator;
    }

    namespace elements {
        class Command;
    }

    class ElementStack;

    class CallInfo {
    public:
        typedef std::vector<boost::shared_ptr<types::Object> >
                            ObjectPointerList;

    public:
        CallInfo();
        CallInfo(ObjectPointerList& args,
                 elements::Command& element);

        ObjectPointerList& arguments() const;

        elements::Command& element();

    private:
        ObjectPointerList* m_args;
        elements::Command* m_element;
    };
}
#endif   // ----- #ifndef CALLINFO_INC  -----
