// =======================================================================
// 
//       Filename:  commandelement.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  20.04.2010 00:42:44
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  COMMANDELEMENT_INC
#define  COMMANDELEMENT_INC
#include "element.hpp"
#include "callable.hpp"
#include "resolvable.hpp"
#include "printable.hpp"
#include <vector>
#include <boost/shared_ptr.hpp>

namespace wesl {
    namespace types {
        class Object;
    }

    namespace elements {
        class Command : public Element,
                        public Callable,
                        public Resolvable,
                        public Printable
        {
            public:
                Command(ElementStack& parent);

                Command(ElementStack& parent,
                        const std::string& name,
                    std::vector<boost::shared_ptr<elements::Element> >& 
                                                params);

                std::string name() const;

                void setName(const std::string& name);

                std::vector<boost::shared_ptr<elements::Element> >&
                    parameters();

                void resolveParameters(
                        std::vector<elements::ElementPtr>& in,
                        std::vector<types::ObjectPtr>& out);
                void print(std::ostream& stream);
                types::ObjectPtr resolve();
                void call();

            private:
                std::string mName;
                std::vector<boost::shared_ptr<Element> > mParams;
        };

        typedef boost::shared_ptr<Command> CommandPtr;
    }
}
#endif   // ----- #ifndef COMMANDELEMENT_INC  -----
