// =======================================================================
// 
//       Filename:  element.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  20.04.2010 00:50:02
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "element.hpp"
#include "../types/object.hpp"
#include "../elementstack.hpp"
#include <sstream>

using namespace std;
namespace fs = boost::filesystem;

namespace wesl {
    using namespace types;

    namespace elements {
        Element::Element()
            : m_parent(0), mType(-1), mLine(-1)
        {

        }

        Element::Element(ElementStack& parent)
            : m_parent(&parent),
            mType(-1), mLine(-1)
        {
        }

        Element::~Element() {
        }

        bool Element::is(Type type) {
            return ((type & mType) == type);
        }

        int Element::line() const
        {
            return mLine;
        }

        void Element::setLine(int line)
        {
            mLine = line;
        }

        ElementStack& Element::parent() {
            if(m_parent == 0)
                throw logic_error("wesl::Element[" + string(typeid(*this).name()) + "]::parent: "
                            "No parent");

            return *m_parent;
        }

        bool Element::hasParent() const
        {
            return (m_parent != 0);
        }

        void Element::setParent(ElementStack& parent) {
            m_parent = &parent;
        }

        void Element::addType(Type type) {
            if(mType != -1)
                mType |= type;
            else
                mType = type;
        }
    }
}
