// =======================================================================
// 
//       Filename:  Element.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  20.04.2010 00:37:38
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#ifndef  ELEMENT_INC
#define  ELEMENT_INC
#include <fstream>
#include <boost/filesystem/path.hpp>
#include <boost/shared_ptr.hpp>

namespace wesl {
    class ElementStack;

    namespace types {
        class Object;
        typedef boost::shared_ptr<Object> ObjectPtr;
    }

    namespace elements {
        class Element
        {
            public:
                enum Type {
                    PRINTABLE = 0x1,
                    RESOLVABLE = 0x2,
                    CALLABLE = 0x4
                };

                Element();

                Element(ElementStack& parent);

                virtual ~Element();

                virtual bool is(Type type);

                virtual int line() const;

                virtual void setLine(int line);

                bool hasParent() const;

                ElementStack& parent();

                void setParent(ElementStack& parent);

                //virtual void print(std::ostream& stream) = 0;
                //virtual types::ObjectPtr resolve() = 0;

                //std::string toString();
                void addType(Type type);

            private:
                ElementStack* m_parent;
                int mType;
                int mLine;
        };

        typedef boost::shared_ptr<Element> ElementPtr;
    }
}

bool operator<<(char& ch, wesl::elements::Element& element);

    wesl::elements::Element& operator>>(char ch, 
                                  wesl::elements::Element& element);
#endif   // ----- #ifndef ELEMENT_INC  -----

