// =======================================================================
// 
//       Filename:  objectwrapper.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  27.06.2010 18:33:20
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "objectwrapper.hpp"
#include "../types/object.hpp"

namespace wesl {
    namespace elements {
        ObjectWrapper::ObjectWrapper(types::ObjectPtr objectPtr)
            : Element(),
            Resolvable(this),
            m_objectPtr(objectPtr)
        {

        }

        types::ObjectPtr ObjectWrapper::resolve() {
            return m_objectPtr;
        }

        ObjectWrapperPtr wrapObject(types::ObjectPtr objectPtr) {
            ObjectWrapperPtr objectWrapperPtr(
                                      new ObjectWrapper(objectPtr));

            return objectWrapperPtr;
        }
    }
}
