// =======================================================================
// 
//       Filename:  objectwrapper.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  27.06.2010 18:30:59
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  OBJECTWRAPPER_INC
#define  OBJECTWRAPPER_INC
#include "element.hpp"
#include "resolvable.hpp"

namespace wesl {
    namespace types {
        class Object;
        typedef boost::shared_ptr<Object>
                        ObjectPtr;
    }
    
    namespace elements {
        class ObjectWrapper : public Element,
                              public Resolvable
        {
        public:
            ObjectWrapper(types::ObjectPtr objectPtr);

            types::ObjectPtr resolve();

        private:
            types::ObjectPtr m_objectPtr;
        };

        typedef boost::shared_ptr<ObjectWrapper>
                        ObjectWrapperPtr;

        ObjectWrapperPtr wrapObject(types::ObjectPtr objectPtr);
    }
}
#endif   // ----- #ifndef OBJECTWRAPPER_INC  -----
