// =======================================================================
// 
//       Filename:  resolvable.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  04.07.2010 17:32:25
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  RESOLVABLE_INC
#define  RESOLVABLE_INC
#include <boost/shared_ptr.hpp>

namespace wesl {
    namespace types {
        class Object;

        typedef boost::shared_ptr<Object> ObjectPtr;
    }
    
    namespace elements {
        class Element;

        class Resolvable
        {
        public:
            Resolvable(Element* base);

            virtual types::ObjectPtr resolve() = 0;
        };

        typedef boost::shared_ptr<Resolvable> ResolvablePtr;
    }
}
#endif   // ----- #ifndef RESOLVABLE_INC  -----
