// =======================================================================
// 
//       Filename:  scriptelement.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  20.04.2010 00:43:24
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  SCRIPTELEMENT_INC
#define  SCRIPTELEMENT_INC
#include "text.hpp"
#include "resolvable.hpp"
#include "callable.hpp"
#include <map>

namespace wesl {
    namespace elements {
        class Element;

        class Script : public Text,
                       public Resolvable,
                       public Callable
        {
            public:
                Script(ElementStack& parent);

                Script(ElementStack& parent, const std::string& spec);

                ~Script();

                std::string specification() const;

                void setSpecification(const std::string& spec);

                void print(std::ostream& stream);

                types::ObjectPtr resolve();

                void call();

            public:
                static std::map<std::string,std::string> RULES;

            private:
                std::string mSpec;
        };

        typedef boost::shared_ptr<Script> ScriptPtr;
    }
}
#endif   // ----- #ifndef SCRIPTELEMENT_INC  -----
