// =======================================================================
// 
//       Filename:  statement.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  18.06.2010 11:27:46
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  ELEMENTS_STATEMENT_INC
#define  ELEMENTS_STATEMENT_INC
#include "element.hpp"
#include <boost/shared_ptr.hpp>

namespace wesl {
    class ElementStack;

    namespace elements {
        class Statement : public Element {
        public:
            enum Type {
                COMMAND,
                RETURN,
                FUNCTION_DEFINITION
            };

            Statement(Type type);
            Statement(ElementStack& parent, Type type);

            Type statementType() const;
            void print(std::ostream& stream);

        private:
            Type m_type;
        };

        typedef boost::shared_ptr<Statement> StatementPtr;
    }
}
#endif   // ----- #ifndef ELEMENTS_STATEMENT_INC  -----
