// =======================================================================
// 
//       Filename:  functiondefinition.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  18.06.2010 17:03:18
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "subroutinedefinition.hpp"
#include "../types/void.hpp"
#include "../elementstack.hpp"
#include "objectwrapper.hpp"
#include "../symbols/function.hpp"
#include "../symbols/macro.hpp"

using namespace std;
using namespace boost;

namespace wesl {
    using namespace symbols;

    namespace elements {
        SubroutineDefinition::SubroutineDefinition(
                const std::string& name,
                SubroutinePtr subroutinePtr)
            : Element(subroutinePtr->body().parent()), 
            Callable(this),
            m_name(name), 
            m_subroutinePtr(subroutinePtr)
        {
        }

        void SubroutineDefinition::call() {
        
            if(m_subroutinePtr->subroutineType() == Subroutine::FUNCTION) 
            {
        
                FunctionPtr funcPtr = 
                    dynamic_pointer_cast<Function>(m_subroutinePtr);
        
                parent().head().dynamicFunctionMap()[m_name] =
                                funcPtr;
        
            }
            else if(m_subroutinePtr->subroutineType() == 
                    Subroutine::MACRO) {
        
                MacroPtr macroPtr = 
                    dynamic_pointer_cast<Macro>(m_subroutinePtr);
        
                parent().head().dynamicMacroMap()[m_name] =
                                macroPtr;
            }
        }
    }
}
