// =======================================================================
// 
//       Filename:  functiondefinition.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  18.06.2010 16:44:34
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  ELEMENTS_FUNCTIONDEFINITION_INC
#define  ELEMENTS_FUNCTIONDEFINITION_INC
#include "element.hpp"
#include "callable.hpp"
#include "../symbols/subroutine.hpp"
#include "../types/object.hpp"
#include <ostream>
#include <boost/shared_ptr.hpp>

namespace wesl {
    namespace elements {
        class SubroutineDefinition : public Element,
                                     public Callable
        {
        public:
            SubroutineDefinition(const std::string& name,
                           symbols::SubroutinePtr SubroutinePtr);

            void call();

        private:
            std::string m_name;
            symbols::SubroutinePtr m_subroutinePtr;
        };

        typedef boost::shared_ptr<SubroutineDefinition>
                                    SubroutineDefinitionPtr;
    }
}
#endif   // ----- #ifndef ELEMENTS_FUNCTIONDEFINITION_INC  -----
