// =======================================================================
// 
//       Filename:  varelement.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  20.04.2010 00:41:33
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  VARELEMENT_INC
#define  VARELEMENT_INC
#include "element.hpp"
#include "resolvable.hpp"

namespace wesl {
    namespace elements {
        class VariableRecall : public Element,
                               public Resolvable
        {
            public:
                VariableRecall(ElementStack& parent);

                VariableRecall(ElementStack& parent, const std::string& name);

                std::string name() const;

                void setName(const std::string& name);

                void print(std::ostream& stream);

                types::ObjectPtr resolve();

            protected:
                bool getChar(char& ch);

            private:
                std::string mName;
        };

        typedef boost::shared_ptr<VariableRecall> VariableRecallPtr;
    }
}
#endif   // ----- #ifndef VARELEMENT_INC  -----
