// =======================================================================
// 
//       Filename:  fileerror.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  12.05.2010 18:21:36
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "fileerror.hpp"
#include <cerrno>

using namespace std;
namespace fs = boost::filesystem;

namespace wesl {
    namespace exceptions {
        FileError::FileError(const string& whatArg,
                             const fs::path& filePath)
            : Exception(whatArg),
            m_file(filePath), m_errno(errno)
        {

        }

        fs::path FileError::file() const
        {
            return m_file;
        }

        int FileError::errNo() const
        {
            return m_errno;
        }
    }
}
