// =======================================================================
// 
//       Filename:  fileerror.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  12.05.2010 18:18:11
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  EXCEPTIONS_FILEERROR_INC
#define  EXCEPTIONS_FILEERROR_INC
#include "exception.hpp"
#include <stdexcept>
#include <boost/filesystem/path.hpp>

namespace wesl {
    namespace exceptions {
        class FileError : public Exception {
        public:
            FileError(const std::string& whatArg,
                      const boost::filesystem::path& filePath);

            ~FileError() throw() {}

            boost::filesystem::path file() const;

            int errNo() const;

        private:
            boost::filesystem::path m_file;
            int m_errno;
        };
    }
}
#endif   // ----- #ifndef EXCEPTIONS_FILEERROR_INC  -----
