// =======================================================================
// 
//       Filename:  parsingerror.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  10.05.2010 22:11:49
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  EXCEPTIONS_PARSINGERROR_INC
#define  EXCEPTIONS_PARSINGERROR_INC
#include "exception.hpp"
#include <stdexcept>
#include <iostream>
#include <boost/filesystem/path.hpp>

namespace wesl {
    namespace exceptions {
        class ParsingError : public Exception {
        public:
            ParsingError(const boost::filesystem::path& 
                                                        file,
                                  const std::string& whatArg);

            ~ParsingError() throw() {}

            const boost::filesystem::path& file() const;

        private:
            boost::filesystem::path m_file;
        };
    }
}
#endif   // ----- #ifndef EXCEPTIONS_PARSINGERROR_INC  -----
