// =======================================================================
// 
//       Filename:  processingerror.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  11.06.2010 23:22:27
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "processingerror.hpp"

using namespace std;

namespace wesl {
    namespace exceptions {
        ProcessingError::ProcessingError(const string& whatArg,
                                         const boost::filesystem::path& 
                                            file,
                                         int line)
            : Exception(whatArg), m_file(file),
            m_line(line)
        {

        }

        ProcessingError::~ProcessingError() throw()
        {

        }

        boost::filesystem::path ProcessingError::file() const
        {
            return m_file;
        }

        int ProcessingError::line() const
        {
            return m_line;
        }
    }
}
