// =======================================================================
// 
//       Filename:  processingerror.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  11.06.2010 23:21:05
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  EXCEPTIONS_PROCESSINGERROR_INC
#define  EXCEPTIONS_PROCESSINGERROR_INC
#include "exception.hpp"
#include <iostream>
#include <boost/filesystem/path.hpp>

namespace wesl {
    namespace elements {
        class Element;
    }
    
    namespace exceptions {
        class ProcessingError : public Exception
        {
        public:
            ProcessingError(const std::string& whatArg,
                            const boost::filesystem::path& file,
                            int line);

            ~ProcessingError() throw();

            boost::filesystem::path file() const;
            int line() const;

        private:
            boost::filesystem::path m_file;
            int m_line;
        };
    }
}
#endif   // ----- #ifndef EXCEPTIONS_PROCESSINGERROR_INC  -----
