// =======================================================================
// 
//       Filename:  function.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  17.06.2010 16:40:12
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "function.hpp"
#include "../callinfo.hpp"
#include "../types/void.hpp"
#include "../elementstack.hpp"
#include "../exceptions/processingerror.hpp"
#include "../elements/command.hpp"
#include <boost/foreach.hpp>
#include <iostream>
#define foreach BOOST_FOREACH

using wesl::exceptions::ProcessingError;
using namespace std;

namespace wesl {
    namespace symbols {
        Function::Function(const boost::filesystem::path& sourcePath,
                           const std::vector<std::string>& 
                                                argumentNameList)
            : Subroutine(FUNCTION, sourcePath, argumentNameList)
        {

        }

        types::ObjectPtr Function::call(CallInfo& callInfo) {
            unsigned int i;

            if(m_argumentNameList.size() != callInfo.arguments().size())
                throw ProcessingError(callInfo.element().name() + 
                        ": invalid number of arguments",
                        callInfo.element().parent().sourcePath(),
                        callInfo.element().line());

            for(i = 0; i < m_argumentNameList.size(); ++i)
            {
                m_body->dynamicVariableMap()[m_argumentNameList.at(i)] =
                    callInfo.arguments()[i];
            }

            return m_body->resolve();
        }
    }
}
