// =======================================================================
// 
//       Filename:  function.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  02.06.2010 21:54:35
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  FUNCTION_INC
#define  FUNCTION_INC
#include "subroutine.hpp"
#include <iostream>
#include <vector>
#include <boost/shared_ptr.hpp>

namespace wesl {
    class CallInfo;
    class ElementStack;

    namespace types {
        class Object;
        typedef boost::shared_ptr<Object> ObjectPtr;
    }

    typedef boost::shared_ptr<types::Object> ObjectPtr;

    namespace symbols {
        class Function : public Subroutine
        {
        public:
            Function(const boost::filesystem::path& sourcePath =
                                boost::filesystem::path(),
                    const std::vector<std::string>& argumentNameList =
                                std::vector<std::string>());
            virtual types::ObjectPtr call(CallInfo& callInfo);
        };

        typedef boost::shared_ptr<Function> FunctionPtr;
    }
}
#endif   // ----- #ifndef FUNCTION_INC  -----
