// =======================================================================
// 
//       Filename:  macro.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  30.06.2010 11:46:43
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "macro.hpp"
#include "../callinfo.hpp"
#include "../types/void.hpp"
#include "../elementstack.hpp"
#include "../exceptions/processingerror.hpp"
#include "../elements/command.hpp"
#include <boost/foreach.hpp>
#include <iostream>
#define foreach BOOST_FOREACH

using wesl::exceptions::ProcessingError;
using namespace std;
namespace fs = boost::filesystem;

namespace wesl {
    namespace symbols {
        Macro::Macro(const fs::path& sourcePath,
                const std::vector<std::string>& 
                            argumentNameList)
            : Subroutine(MACRO, sourcePath, argumentNameList)
        {

        }

        void Macro::call(CallInfo& callInfo, std::ostream& stream) {
            unsigned int i;

            if(m_argumentNameList.size() != callInfo.arguments().size())
                throw ProcessingError(callInfo.element().name() + 
                        ": invalid number of arguments",
                        callInfo.element().parent().sourcePath(),
                        callInfo.element().line());

            for(i = 0; i < m_argumentNameList.size(); ++i)
            {
                m_body->dynamicVariableMap()[m_argumentNameList.at(i)] =
                    callInfo.arguments()[i];
            }

            m_body->print(stream);
        }
    }
}
