// =======================================================================
// 
//       Filename:  subroutine.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  30.06.2010 11:58:36
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "subroutine.hpp"
#include "../elementstack.hpp"

using namespace std;
using namespace boost::filesystem;

namespace wesl {
    using namespace elements;

    namespace symbols {
        Subroutine::Subroutine(Type type, 
                const path& sourcePath,
                const vector<string>& argumentNameList)
            : m_argumentNameList(argumentNameList),
            m_body(new ElementStack(sourcePath)),
            m_type(type)
        {

        }

        void Subroutine::addBodyElement(ElementPtr elementPtr) {
            m_body->push_back(elementPtr);
        }

        ElementStack& Subroutine::body() {
            return *m_body;
        }

        Subroutine::Type Subroutine::subroutineType() const
        {
            return m_type;
        }
    }
}
