// =======================================================================
// 
//       Filename:  subroutine.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  30.06.2010 11:54:06
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  SUBROUTINE_INC
#define  SUBROUTINE_INC
#include <vector>
#include <iostream>
#include <vector>
#include <iostream>
#include <boost/shared_ptr.hpp>
#include <boost/filesystem/path.hpp>

namespace wesl {
    class ElementStack;

    namespace elements {
        class Element;
        typedef boost::shared_ptr<Element> ElementPtr;
    }

    namespace symbols {
        class Subroutine {
        public:
            enum Type {
                FUNCTION,
                MACRO
            };

        protected:
            Subroutine(Type type,
                    const boost::filesystem::path& sourcePath,
                    const std::vector<std::string>& argumentNameList);

        public:
            virtual void addBodyElement(elements::ElementPtr elementPtr);
            ElementStack& body();

            Type subroutineType() const;

        protected:
            std::vector<std::string> m_argumentNameList;
            boost::shared_ptr<ElementStack> m_body;

        private:
            Type m_type;
        };

        typedef boost::shared_ptr<Subroutine>
            SubroutinePtr;
    }
}
#endif   // ----- #ifndef SUBROUTINE_INC  -----
