// =======================================================================
// 
//       Filename:  object.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  23.04.2010 22:05:31
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  OBJECT_INC
#define  OBJECT_INC
#include <ostream>

namespace boost {
    template <typename T>
        class shared_ptr;
}

namespace wesl {
    namespace types {
        class Object;
        typedef boost::shared_ptr<Object> ObjectPtr;

        class Object
        {
        public:
            enum Type {
                INTEGER,
                FLOAT,
                STRING,
                VOID
            };

        public:
            Object(Type type);
            virtual ~Object();

            virtual void setType(Type type);
            virtual Type objectType() const;

            virtual void print(std::ostream& stream) = 0;
            std::string toString();

        private:
            Type mType;
        };
    }
}
#endif   // ----- #ifndef OBJECT_INC  -----
