// =======================================================================
// 
//       Filename:  string.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  23.04.2010 22:13:53
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  STRING_INC
#define  STRING_INC
#include <iostream>
#include "object.hpp"

namespace wesl {
    namespace types {
        template <typename T>
        class BasicString 
            : public std::basic_string<T>,
              public Object
        {
        public:
            BasicString();
            BasicString(const char* str);
            BasicString(const std::basic_string<T>& str);

            void print(std::ostream& stream);
        };

        typedef BasicString<char> String;
        typedef boost::shared_ptr<String> StringPtr;

        template <typename T>
        BasicString<T>::BasicString()
            : std::basic_string<T>(), Object(STRING)
        {

        }

        template <typename T>
        BasicString<T>::BasicString(const char* str)
            : std::basic_string<T>(str), Object(STRING)
        {

        }

        template <typename T>
        BasicString<T>::BasicString(const std::basic_string<T>& str)
            : std::basic_string<T>(str), Object(STRING)
        {

        }

        template <typename T>
        void BasicString<T>::print(std::ostream& stream) {
            stream << static_cast<std::string>(*this);
        }
    }
}
#endif   // ----- #ifndef STRING_INC  -----
