// =======================================================================
// 
//       Filename:  configparser.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  30.05.2010 21:14:54
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "configparser.hpp"
#include <wesl/exceptions/fileerror.hpp>
#include <fstream>
#include <yaml.h>

namespace fs = boost::filesystem;
using namespace std;
using wesl::exceptions::FileError;

namespace webplodder {
    ConfigParser::ConfigParser() {

    }

    void ConfigParser::parseScriptRules(const fs::path& filePath,
            map<string,string>& stdMap)
    {
        ifstream in(filePath.string().c_str());
        if(in.good()) {
            YAML::Parser parser(in);

            YAML::Node doc;

            parser.GetNextDocument(doc);
            YAML::Iterator it;

            const YAML::Node *pRules;
            if((pRules = doc.FindValue("script_rules")) != 0) {
                string key;

                for(it = pRules->begin(); it != pRules->end(); ++it) {
                    it.first() >> key;
                    it.second() >> stdMap[key];
                }
            } 

            in.close();
        }
        else
            throw FileError("unable to open", filePath);
    }
}
