// =======================================================================
// 
//       Filename:  title.cpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  03.06.2010 14:52:47
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================

#include "title.hpp"
#include "../page/page.hpp"
#include <wesl/callinfo.hpp>
#include <wesl/types/string.hpp>
#include <wesl/exceptions/processingerror.hpp>
#include <wesl/elements/command.hpp>
#include <wesl/elements/objectwrapper.hpp>

using namespace std;
using namespace boost;

namespace webplodder {
    namespace functions {
        wesl::types::ObjectPtr
            Title::call(wesl::CallInfo& callInfo)
        {
            wesl::CallInfo::ObjectPointerList& args = 
                                        callInfo.arguments();

            if(args.size() > 0) {
                throw wesl::exceptions::ProcessingError(
                        callInfo.element().name() + 
                        ": doesn't require any "
                        "arguments",
                        callInfo.element().parent().sourcePath(),
                        callInfo.element().line());
            }

            wesl::types::StringPtr stringPtr(
                    new wesl::types::String(page().title()));
            return stringPtr;
        }
    }
}
