// =======================================================================
// 
//       Filename:  pathlist.hpp
// 
//    Description:  
// 
//        Version:  1.0
//        Created:  09.05.2010 22:45:11
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Dominik 'domachine' Burgdörfer (-), dominik.burgdoerfer@googlemail.com
//        Company:  -
// 
// =======================================================================


#ifndef  PATHLIST_INC
#define  PATHLIST_INC
#include <list>
#include <boost/filesystem/path.hpp>

namespace webplodder {
    namespace utils {
        /**
         * @brief List of boost::filesystem::path objects.
         */
        class PathList : public std::list<boost::filesystem::path> {
        public:
            /**
             * @brief Constructs empty list.
             */
            PathList();

            /**
             * @brief Checks whether the list contains the path.
             */
            bool contains(const boost::filesystem::path& path);
        };
    }
}
#endif   // ----- #ifndef PATHLIST_INC  -----
